MBSTOWCS(3)

NAME
mbstowcs - converts a multibyte character string to a wide-character string

SYNOPSIS
#include <stdlib.h>
size_t
mbstowcs(wchar_t * restrict pwcs, const char * restrict s, size_t n);

DESCRIPTION
The mbstowcs() converts a null-terminated multibyte character string pointed to by s to the corresponding wide-character string and stores it in the array pointed to by pwcs. This function may modify the first at most n elements of the array pointed to by pwcs. Each character will be converted as if mbtowc(3) is continuously called, except the internal state of mbtowc(3) will not be affected.

For state-dependent encoding, mbstowcs() implies the multibyte character string pointed to by s always begin with an initial state.

These are the special cases:

pwcs == NULL
    mbstowcs() returns the number of elements to store the whole wide-character string corresponding to the multibyte character string pointed to by s. In this case, n is ignored.

s == NULL
    Undefined (may causes the program to crash).

RETURN VALUES
mbstowcs() returns:

0 or positive
    The value returned is the number of elements stored in the array pointed to by pwcs, except for a terminating null wide character (if any). If pwcs is not null and the value returned is equal to n, the wide-character string pointed to by pwcs is not null terminated. If pwcs is a null pointer, the value returned is the number of elements to contain the whole string converted, except for a terminating null wide character.

(size_t)-1
    The array indirectly pointed to by s contains a byte sequence forming invalid character. In this case, mbstowcs() sets errno to indicate the error.

ERRORS
mbstowcs() may cause an error in the following cases:

[EILSEQ]
    s points to the string containing invalid or incomplete multibyte character.

SEE ALSO
mbtowc(3), setlocale(3)

STANDARDS
The mbstowcs() function conforms to ansiC. The restrict qualifier is added at ISO/IEC 9899/199 (“ISO C99”).